//実際にデモンストレーション動画で使ったプログラムを記載します。
//2024/11/18 Machia/MachiaWorks

//実際にはこれらのフレーズをリアルタイムで入力・修正しています。（なので不足少しあるかも）
//それほど全体の記述量は多くないため、よかったら参考にしてみてください。


//以下、記述方法について説明
//=================================================================

//フレーズを演奏するループの長さを変更します。
//TidalCyclesでいうところのサイクルのスピードになります。
//数値は秒数になります。現状はBPMを考慮した速さは自分で計算することになります。
//例：１小節の拍数×小節数÷BPM＝演奏時間
//参考URL　https://er-music.jp/theory/2526/
rs_speed(1.9*4)


//フレーズの内容を変数に格納します。
//sq_mml関数にMMLを記載すると、配列が出力されます。
//この配列を読み込んでフレーズが演奏されます。
//なお、print関数も持っており、GUI上に文字列を表示できます。

//下記のように大カッコを複数記載して音の長さ・発音タイミングを変更可能、
//記載ではキックの打ち込みで4小節分を想定しており、
//各小節でキックの4回目を少しずつ変更しております。
bd=sq_mml("o4 [cccc][ccc[cc]][cccc][ccc[cccc]]")

//上記で入力したフレーズをMIDIで出力させます。
//専用の関数は「rc_midi0～rc_midi7」まであり、それぞれでトラック番号に差異があります。
rc_midi5(bd)


//フレーズの内容を変数に格納します。
//下記のように大カッコで区切ってフレーズの形状を自由に変更できます。
//例：[eeee][eee]という記載方法だと、4つ打ち＋3つ打ちという
//ちょっとトリッキーなフレーズ作成も可能です。
hh=sq_mml("o4 [eeee][eeee][eeee][eeee]")

//上記で入力したフレーズをMIDIで出力させます。
//配列を複数並べることについて算術演算に対応しているため、
//掛け算でフレーズを複数入力して早回しさせるような事も可能です。
rc_midi6( hh*4)


//フレーズの内容を変数に格納します。
//休符の入力を行っています。
cr=sq_mml("o4 [edrd][rdrd][rdrd][rdrd]")

//上記で入力したフレーズをMIDIで出力させます。
rc_midi7(cr*4)


//フレーズの内容を変数に格納します。
//オクターブベースのようなフレーズを作りたい場合、音の高さをMML中に指定可能
bass=sq_mml("o2 [dd>d<d][dd>d<d][ee>e<e][ee>e<e]")
bass2=sq_mml("o2 [dd>d<d][dd>d<d][cc>c<c][cc>c<c]")
bass_end=sq_mml("o2 d")

//上記で入力したフレーズをMIDIで出力させます。
rc_midi0(bass_end)


//フレーズの内容を変数に格納します。
//大カッコを付けない場合、この内容で配列が1個作られます。（スピード変更等考慮なし）
seq=sq_mml("o6  defgb>ceg")

//上記で入力したフレーズをMIDIで出力させます。
//掛け算で配列を増加、8回分鳴らしてます。
//つまり、8倍速でフレーズが演奏されます。
rc_midi4(seq*8)


//フレーズの内容を変数に格納します。
//愚直に和音を計算して入力してます。
//今のところ相対的な譜面入力機能は用意していないですが、
//あると便利そうですねー。（追加実装を検討）
pad1=sq_mml("o5 dfdc")
pad2=sq_mml("o5 fafe")

//上記で入力したフレーズをMIDIで出力させます。
//現行のバージョンでは和音を考慮してないため、下記のように2トラック利用しています。
rc_midi1(pad1)
rc_midi2(pad2)